package repostatus

import 	(
	"go.wit.com/log"
	"go.wit.com/gui/gui"
)

// reports externally if something has changed
// since the last time it was asked about it
func (rs *RepoStatus) Changed() bool {
	if ! rs.Ready() {return false}
	if rs.changed {
		rs.changed = false
		return true
	}
	return false
}

func (rs *RepoStatus) Make() {
	if ! rs.Ready() {return}
	log.Log(CHANGE, "Make() window ready =", rs.ready)
	rs.window.Make()
	rs.ready = true
}
func (rs *RepoStatus) Draw() {
	if ! rs.Ready() {return}
	log.Log(CHANGE, "Draw() window ready =", rs.ready)
	rs.window.Draw()
	rs.ready = true
}
func (rs *RepoStatus) Draw2() {
	if ! rs.Ready() {return}
	log.Log(CHANGE, "draw(rs) ready =", rs.ready)
	draw(rs)
}

func (rs *RepoStatus) Show() {
	if ! rs.Ready() {return}
	log.Log(CHANGE, "Show() window ready =", rs.ready)
	rs.window.Show()
	rs.hidden = false
}

func (rs *RepoStatus) Hide() {
	if ! rs.Ready() {return}
	log.Log(CHANGE, "Hide() window ready =", rs.ready)
	rs.window.Hide()
	rs.hidden = true
}

func (rs *RepoStatus) Toggle() {
	if ! rs.Ready() {return}
	log.Log(CHANGE, "Toggle() window ready =", rs.ready)
	if rs.hidden {
		rs.Show()
	} else {
		rs.Hide()
	}
}

func (rs *RepoStatus) Ready() bool {
	log.Log(SPEW, "Ready() maybe not ready? rs =", rs)
	if rs == nil {return false}
	if rs.window == nil {return false}
	return rs.ready
}

func (rs *RepoStatus) Initialized() bool {
	log.Log(CHANGE, "checking Initialized()")
	if rs == nil {return false}
	if rs.parent == nil {return false}
	return true
}

func (rs *RepoStatus) SetParent(p *gui.Node) {
	log.Log(CHANGE, "Attempting SetParent")
	if rs == nil {return}
	if rs.parent == nil {
		log.Log(CHANGE, "SetParent =", p)
		rs.parent = p
		return
	} else {
		log.Log(CHANGE, "SetParent was already set to =", rs.parent)
	}
}
