package repostatus

import 	(
	"go.wit.com/log"

	"go.wit.com/gui/gui"
	"go.wit.com/gui/gadgets"
)

func New(p *gui.Node, path string) *RepoStatus {
	rs := &RepoStatus {
		hidden: true,
		ready: false,
		parent: p,
		repopath: path,
	}
	rs.tags = make(map[string]string)
	return rs
}

func (rs *RepoStatus) InitWindow() {
	if ! rs.Initialized() {
		log.Log(WARN, "not initalized yet (no parent for the window?)")
		return
	}
	if rs.window != nil {
		log.Log(WARN, "You already have a window")
		rs.ready = true
		return
	}

	log.Log(WARN, "Creating the Window")
	rs.window = gadgets.NewBasicWindow(rs.parent, "GO Repo Details")
	rs.ready = true
}
